Barbrawl = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceHook-2.0", "AceDB-2.0", "AceConsole-2.0")

--local L = AceLibrary("AceLocale-2.0"):new("Barbrawl")
local AceOO = AceLibrary("AceOO-2.0")

print = function(msg) if msg then DEFAULT_CHAT_FRAME:AddMessage(msg) end end

local pageOffset = 40

function Barbrawl:OnInitialize()
	self:RegisterDB("BarbrawlDB")
	
	local Barbrawl_DEFAULT_OPTIONS = {
		HideMainMenu = true,
		cooldown = true,
		oorColor = true,
		hotkey = true,
		chat = true,
		bar1 = {
			x = 20,
			y = 10,
			buttons = {},
			padding = 8,
			growth = "right",
			scale = 0.75,
			shift = true,
			stance = true,
			deleted = false,
			borders = false,
		},
		bar2 = {
			x = 20,
			y = 40,
			buttons = {},
			padding = 8,
			growth = "right",
			scale = 0.75,
			shift = true,
			stance = true,
			deleted = false,
			borders = false,
		},
		bar3 = {
			x = 20,
			y = 70,
			buttons = {},
			padding = 8,
			growth = "right",
			scale = 0.75,
			shift = true,
			stance = true,
			deleted = false,
			borders = false,
			
		},
--[[		bar4 = {
			x = 100,
			y = 400,
			buttons = {},
			padding = 8,
			growth = "right",
			scale = 0.75,
			shift = true,
			stance = true,
			deleted = false,
			borders = false,
			
		},
		bar5 = {
			x = 100,
			y = 500,
			buttons = {},
			padding = 8,
			growth = "right",
			scale = 0.75,
			shift = true,
			stance = true,
			deleted = false,
			borders = false,
			
		},]]
		keys = {}
	}
	self:RegisterDefaults('profile', Barbrawl_DEFAULT_OPTIONS)
	self:SetDefaults()
	
	self.dewdrop = AceLibrary("Dewdrop-2.0")
	
	local BarbrawlMenu = {
		type = "group",
		args = {
			config = {
				name = 'config',
				desc = 'configdesc',
				type = 'execute',
				func = function()
					local menu = Barbrawl:CreateDewdrop()
					self.dewdrop:InjectAceOptionsTable(self, menu)
					self.dewdrop:Register(UIParent, 'children', function() self.dewdrop:FeedAceOptionsTable(menu) end,'cursorX', true, 'cursorY', true)
					self.dewdrop:Open(UIParent)
				end,
			},
			reset = {
				name = 'reset',
				desc = 'configdesc',
				type = 'execute',
				func = function()
					Barbrawl:Reset()
				end,
			}			
		}
	}
	
	self:RegisterChatCommand({ "/Barbrawl" }, BarbrawlMenu )	
end

function Barbrawl:SetDefaults()
	local buttonDefaults = {
		bar1 = {1,2,3,4,5,6,7,8},
		bar2 = {9,10,11,12,13,14,15,16},
		bar3 = {17,18,19,20,21,22,23,24},
--		bar4 = {18,19,20,21,22},
--		bar5 = {23,24,25,26,27,28},
	}
	for k,v in pairs(self.db.profile) do
		if type(v) == "table" and k ~= "keys" then
			if v.buttons and table.getn(v.buttons) == 0 and not (v.zeroButtons == true) then
				v.buttons = buttonDefaults[k]
			end
		end
	end
end

function Barbrawl:PopulateButtonPool()
	self.AvailableButtons = {}	
	for i=1,40 do
		self.AvailableButtons[i] = true
	end
end

function Barbrawl:Reset()
	self:ResetDB("profile")
	self:SetDefaults()
	
	self:PopulateButtonPool()
	
	for k,v in pairs(self.bars) do
		v:Reset()
	end
end

function Barbrawl:OnEnable()
	BINDING_HEADER_Barbrawl = "Barbrawl"

	self:PopulateButtonPool()
	
	self:UpdateMainMenu()
	self.bindingIndex = {}
	self.revbindingIndex = {}
	self:CreateBars()
	self.lock = true
	
	self:CreateDewdrop()
	self:ScheduleRepeatingEvent(self.HotkeyCheck, 0.1, self)
end

function Barbrawl:CreateDewdrop(arg)
	local barTable = {}
	
	for k,v in pairs(self.bars) do
		local name = "Bar "..v.id
		local order = v.id
		local class = "bar"..order
		if self.db.profile[class] and self.db.profile[class].deleted == nil and order > 0 then
			local table = {
				name = name, 
				type = 'group',
				desc = name.." Settings",
				order = order,
				args = {	
					Scale = {
							name = "Scale",
							type = 'range',
							desc = "ScaleDesc",
							min = 0.5,
							max = 2,
							step = 0.005,
							isPercent = true,
							get = function()
								return self.db.profile[class].scale
							end,
							set = function(option)
								self.db.profile[class].scale = option	
								self.bars[order]:UpdateScale()
							end,
							order = 1,
					},
					Padding = {
							name = "Padding",
							type = 'range',
							desc = "ScaleDesc",
							min = 0,
							max = 20,
							step = 0.1,
							get = function()
								return self.db.profile[class].padding
							end,
							set = function(option)
								self.db.profile[class].padding = option	
								self.bars[order]:GroupButtons()
							end,
							order = 2,
					},
					Buttons = {
							name = "Buttons",
							type = 'range',
							desc = "ButtonDesc",
							min = 0,
	--						max = self:FreeButtons(),
							max = 40,
							step = 1,
							get = function()
								return table.getn(self.bars[order].database.buttons)
							end,
							set = function(option)
								self.bars[order]:SetButtons(option)
							end,
							order = 3,
					},				
					Growth = {
						name = "Growth",
						type = 'text',
						desc = "BordersDesc",
						get = function()
							return self.db.profile[class].growth
						end,
						set = function(option)
							self.db.profile[class].growth = option	
							self.bars[order]:GroupButtons()
						end,
						validate = {"Horizontal", "Vertical"},
						order = 4,
					},
					ShiftDown = {
						name = "ShiftDown",
						type = 'toggle',
						desc = "ShiftDown",
						get = function()
							return self.db.profile[class].shift
						end,
						set = function(option)
							self.db.profile[class].shift = option
							self.bars[order]:GroupButtons()
						end,
						order = 5,				
					},
					CtrlDown = {
						name = "CtrlDown",
						type = 'toggle',
						desc = "AltDown",
						get = function()
							return self.db.profile[class].ctrl
						end,
						set = function(option)
							self.db.profile[class].ctrl = option
							self.bars[order]:GroupButtons()
						end,
						order = 6,				
					},				
					Stance = {
						name = "Stance",
						type = 'toggle',
						desc = "Stance",
						get = function()
							return self.db.profile[class].stance
						end,
						set = function(option)
							self.db.profile[class].stance = option
							self.bars[order]:GroupButtons()
						end,
						order = 7,				
					},
					Borders = {
						name = "Borders",
						type = 'toggle',
						desc = "Stance",
						get = function()
							return self.db.profile[class].borders
						end,
						set = function(option)
							self.db.profile[class].borders = option
							self:TriggerEvent("Barbrawl_BorderOption")
						end,
						order = 7,				
					},					
					Hidden = {
						name = "Hidden",
						type = 'toggle',
						desc = "Stance",
						get = function()
							return self.db.profile[class].hidden
						end,
						set = function(option)
							self.db.profile[class].hidden = option
							self.bars[order]:GroupButtons()
						end,
						order = 8,				
					},
					delete = {
						name = 'Delete Bar',
						desc = 'deletedesc',
						type = 'execute',
						func = function()
							self.bars[order]:Delete()
							self.dewdrop:Close()
						end,
					}				
				}
			}
			barTable[v.name] = table
		end
	end
		
		
	local BarbrawlDewMenu = {
		type= 'group',
		args = {
			AddonHeader = {
				name = "Barbrawl",
				type = 'header',
				desc = "desc",
				order = 1,
			},
			Bars = {
				name = "Bars",
				type = 'group',
				desc = "BarDesc",
				args = barTable,
				order = 2,
			},
			cooldown = {
				name = "Cooldown Timers",
				type = 'toggle',
				desc = "cooldownDesc",
				get = function()
					return self.db.profile.cooldown
				end,
				set = function(option)
					self.db.profile.cooldown = option
				end,
				order = 3,				
			},
			oorcolor = {
				name = "Out of Range Coloring",
				type = 'toggle',
				desc = "oorDesc",
				get = function()
					return self.db.profile.oorColor
				end,
				set = function(option)
					self.db.profile.oorColor = option
					self:TriggerEvent("Barbrawl_RedRangeOption")
				end,
				order = 4,				
			},
			hotkey = {
				name = "Show Hotkeys",
				type = 'toggle',
				desc = "oorDesc",
				get = function()
					return self.db.profile.hotkey
				end,
				set = function(option)
					self.db.profile.hotkey = option
					self:TriggerEvent("Barbrawl_HotkeyOption")
				end,
				order = 5,				
			},
			hotkey = {
				name = "Block Keys in Chat",
				type = 'toggle',
				desc = "bkcDesc",
				get = function()
					return self.db.profile.chat
				end,
				set = function(option)
					self.db.profile.chat = option
--					self:TriggerEvent("Barbrawl_HotkeyOption")
				end,
				order = 6,				
			},				
			newbar = {
				name = "Create New Actionbar",
				type = 'execute',
				desc = "newbarDesc",
				func = function()
					Barbrawl:CreateNewBar()
					self.dewdrop:Close()
				end,
				order = 7,				
			},
			configkeys = {
				name = "Set Hotkeys",
				type = 'toggle',
				desc = "LockedDesc",
				get = function()
					return self.hotkey
				end,
				set = function(option)
					self.hotkey = option
					self:Print("You can now right-click buttons to set their hotkeys.")
				end,
				order = 9,				
			},			
			lock = {
				name = "Lock Actionbars",
				type = 'toggle',
				desc = "LockedDesc",
				get = function()
					return self.lock
				end,
				set = function(option)
					self.lock = option
					Barbrawl:Lock()
				end,
				order = 10,				
			},			
		}
	}
	return BarbrawlDewMenu
end

function Barbrawl:HotkeyCheck()
	if ChatFrameEditBox:IsVisible() and self.db.profile.chat == true then
		return
	end
	if IsAltKeyDown() and not self.alt then
		self.alt = true
		self:TriggerEvent("Barbrawl_AltDown")
	elseif not (IsAltKeyDown()) and self.alt == true then
		self.alt = false
		self:TriggerEvent("Barbrawl_AltUp")
	end
	if IsShiftKeyDown() and not self.shift then
		self.shift = true
		self:TriggerEvent("Barbrawl_ShiftDown")
	elseif not (IsShiftKeyDown()) and self.shift == true then
		self.shift = false
		self:TriggerEvent("Barbrawl_ShiftUp")
	end
	if IsControlKeyDown() and not self.control then
		self.control = true
		self:TriggerEvent("Barbrawl_ControlDown")
	elseif not (IsControlKeyDown()) and self.control == true then
		self.control = false
		self:TriggerEvent("Barbrawl_ControlUp")
	end
end

function Barbrawl:UpdateMainMenu()
	if self.db.profile.HideMainMenu == true then
		MainMenuBar:Hide()
	else
		MainMenuBar:Show()
	end
end

function Barbrawl:Lock()
	if self.lock == true then
		self:TriggerEvent("Barbrawl_Lock")
	else
		self:TriggerEvent("Barbrawl_Unlock")	
	end
end

function Barbrawl:CreateBars()
	self.bars = {}
	for k,v in pairs(self.db.profile) do
		if type(v) == "table" and string.find(k,"bar") and not v.deleted then
			local id = string.gsub(k,"bar","")
			if self.bars[id] == nil then
				self:CreateActionBar(tonumber(id))
			else
				self.bars[id]:Reset()
			end
		end
	end
end

function Barbrawl:CreateNewBar()
	for i=1,(table.getn(self.bars)+1) do
		if self.bars[i] and self.bars[i].deleted == true then
			self.bars[i]:Reset()
			return
		elseif self.bars[i] == nil then
			self:CreateActionBar(i)
			return
		end
	end
	
end

function Barbrawl:CreateActionBar(id)
	self.bars[id] = Barbrawl.ActionBarTemplate:new(id)
--	if id > table.getn(self.bars) then
--		table.setn(self.bars,id)
--	end
end

function SetBindingNew(v1,v2)
	if string.find(v2,"Barbrawl") then
		local _,_,id = string.find(v2, "(%d+)")
		Barbrawl:BindKeyToFrame(v1,id)
	else
		SetBinding(v1,v2)
	end
end

function Barbrawl:GrabKey(key)
	if Barbrawl["ActionButton"..self.configFrame] then
		Barbrawl["ActionButton"..self.configFrame].GetBinding(Barbrawl["ActionButton"..self.configFrame],key)
--		Barbrawl["ActionButton"..self.configFrame].GetBinding(Barbrawl["ActionButton"..self.configFrame],"MiddleButton")
	end
	PCHotkeyWindow:Hide()
end





Barbrawl.ActionBarTemplate = AceOO.Class("AceEvent-2.0","AceHook-2.0")

function Barbrawl.ActionBarTemplate.prototype:init(id)
	Barbrawl.ActionBarTemplate.super.prototype.init(self)
	
	self.id = id
	self.name = "ActionBar"..id
	
	self:CreateAnchor()
	self:Reset()
	
	self:RegisterEvent("Barbrawl_Lock")
	self:RegisterEvent("Barbrawl_Unlock")
	self:RegisterEvent("Barbrawl_BorderOption")	
end

function Barbrawl.ActionBarTemplate.prototype:Reset()
	local barName = "bar"..self.id
	if Barbrawl.db.profile[barName] == nil or Barbrawl.db.profile[barName].deleted == true then
		Barbrawl.db.profile[barName] = {}	
		Barbrawl.db.profile[barName].padding = 8
		Barbrawl.db.profile[barName].growth = "Horizontal"
		Barbrawl.db.profile[barName].scale = 0.75
		Barbrawl.db.profile[barName].shift = true
		Barbrawl.db.profile[barName].stance = true
		Barbrawl.db.profile[barName].buttons = {}
	end
	
	self.database = Barbrawl.db.profile["bar"..self.id]
	
	if not self.database.buttons then
		self.database.buttons = {}
	end	
	
	self.buttons = self.database.buttons	
	self.database.deleted = nil
	
	for k,v in pairs(self.buttons) do
		Barbrawl.AvailableButtons[v] = false
	end
		
	self:CreateButtons()
	self:UpdateScale()
	self:GroupButtons()
	self:LoadPosition()
	
	self.deleted = false
end

function Barbrawl.ActionBarTemplate.prototype:Delete()
	self:SetButtons(0)
	self.anchor:Hide()
	Barbrawl.db.profile["bar"..self.id] = {deleted = true}
	self.deleted = true
end

function Barbrawl.ActionBarTemplate.prototype:CreateButtons()
	for k,v in pairs(self.buttons) do
		if not Barbrawl["ActionButton"..v] then
			Barbrawl["ActionButton"..v] = Barbrawl.ActionButtonTemplate:new(v)
		end
	end
end

function Barbrawl.ActionBarTemplate.prototype:CreateAnchor()
	local frameName = "ActionBar"..self.id.."Anchor"
	if not getglobal(frameName) then
		self.anchor = CreateFrame("Button", frameName, UIParent)
		self.anchor:EnableMouse(true)
		self.anchor:SetMovable(true)
		self.anchor:RegisterForDrag("LeftButton")
		self.anchor:SetWidth(10)
		self.anchor:SetHeight(10)
		self.anchor:SetBackdrop({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 16, edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border", edgeSize = 16, insets = {left = 5, right = 3, top = 3, bottom = 5},})
		self.anchor:ClearAllPoints()
		self.anchor:SetBackdropColor(0, 0, 0, 0)
		self.anchor:SetBackdropBorderColor(0.5, 0.5, 0, 0)
		self.anchor:SetFrameStrata("HIGH")
		self.anchor.text = self.anchor:CreateFontString(nil, "ARTWORK")
		self.anchor.text:SetFontObject(GameFontNormal)
		self.anchor.text:SetText("Bar "..self.id)
		self.anchor.text:Show()
		self.anchor.text:SetPoint("CENTER", self.anchor, "CENTER",0,0)
		self.anchor:SetBackdropColor(0, 0.5, 0, 0.5)
		self.anchor:SetScript("OnDragStart", function() self.button1.frame:StartMoving() end)
		self.anchor:SetScript("OnDragStop", function() self:OnDragStop() end)
		self.anchor:SetScript("OnEnter", function() self.anchor:SetBackdropBorderColor(0.5, 0.5, 0, 1) end)
		self.anchor:SetScript("OnLeave", function() self.anchor:SetBackdropBorderColor(0, 0, 0, 0) end)
		self.anchor:SetScript("OnClick", function() self:AnchorOnClick(arg1) end)
		self.anchor:RegisterForClicks("LeftButtonUp","RightButtonUp","MiddleButtonUp","Button4Up","Button5Up")

		self.anchor:Hide()
	end
end

function Barbrawl.ActionBarTemplate.prototype:AnchorOnClick(button)
	if button == "RightButton" then
		local menu = Barbrawl:CreateDewdrop(true)
--		Barbrawl.dewdrop:InjectAceOptionsTable(self, menu)	
		Barbrawl.dewdrop:Register(self.anchor, 'children', function() Barbrawl.dewdrop:FeedAceOptionsTable(menu) end,'cursorX', true, 'cursorY', true)
		Barbrawl.dewdrop:Open(self.anchor)
	end
end

function Barbrawl.ActionBarTemplate.prototype:OnDragStop()
	self.button1.frame:StopMovingOrSizing()
	self:SavePosition()
end

function Barbrawl.ActionBarTemplate.prototype:Barbrawl_Unlock()
	if self.button1 then
		self.anchor:Show()	
	end
end

function Barbrawl.ActionBarTemplate.prototype:Barbrawl_Lock()
	self.anchor:Hide()
end

function Barbrawl.ActionBarTemplate.prototype:Barbrawl_BorderOption()
	for k,v in ipairs(self.buttons) do
		Barbrawl["ActionButton"..v].borders = self.database.borders
		Barbrawl["ActionButton"..v]:SetLook()
	end
end

function Barbrawl.ActionBarTemplate.prototype:SetButtons(number)
	local diff = math.abs(number-table.getn(self.buttons))
	if number < table.getn(self.buttons) then
		for i=table.getn(self.buttons),1,-1 do
			if diff > 0 then
				self:RemoveButton(self.buttons[i])
				diff = diff - 1
			end
			if diff == 0 then
				break
			end			
		end
	elseif  number > table.getn(self.buttons) then
		for k,v in ipairs(Barbrawl.AvailableButtons) do
			if v == true and diff > 0 then
				self:AddButton(k)
				diff = diff - 1
			end
			if diff == 0 then
				break
			end
		end
	end
	if table.getn(self.buttons) == 0 then
		self.database.zeroButtons = true
	else
		self.database.zeroButtons = false
	end
	self:CreateButtons()
	self:GroupButtons()
	self:UpdateScale()	
end

function Barbrawl.ActionBarTemplate.prototype:AddButton(id)
	if Barbrawl.AvailableButtons[id] == true then
		Barbrawl.AvailableButtons[id] = false
		table.insert(self.buttons,id)
		table.sort(self.buttons)
	end
end

function Barbrawl.ActionBarTemplate.prototype:RemoveButton(id)
	for k,v in pairs(self.buttons) do
		if v == id then
			table.remove(self.buttons,id)
			table.sort(self.buttons)			
			Barbrawl["ActionButton"..v].group = nil
			Barbrawl.db.profile.keys[v] = nil
			Barbrawl["ActionButton"..v].frame:Hide()
			Barbrawl["ActionButton"..v]:UpdateTexture()
			Barbrawl["ActionButton"..v].frame:ClearAllPoints()
			Barbrawl["ActionButton"..v]:SetButtons()
			Barbrawl.AvailableButtons[v] = true
		end
	end
end


function Barbrawl.ActionBarTemplate.prototype:GroupButtons()
	local point1,point2
	local x,y = 0,0
	if self.database.growth == "Vertical" then
		point1 = "TOP"
		point2 = "BOTTOM"
		y = -(self.database.padding)
	else
		point1 = "LEFT"
		point2 = "RIGHT"
		x = self.database.padding
	end
	self.buttonEnd = nil
	self.button1 = nil
	for k,v in ipairs(self.buttons) do

		Barbrawl["ActionButton"..v].shift = self.database.shift
		Barbrawl["ActionButton"..v].alt = self.database.alt
		Barbrawl["ActionButton"..v].control = self.database.control
		Barbrawl["ActionButton"..v].stance = self.database.stance
		Barbrawl["ActionButton"..v].borders = self.database.borders
		
		if self.buttons[k-1] then
			Barbrawl["ActionButton"..v].frame:ClearAllPoints()
			Barbrawl["ActionButton"..v].frame:SetPoint(point1,"BarbrawlButton"..self.buttons[k-1],point2,x,y)
			if not self.buttons[k+1] then
				self.buttonEnd = Barbrawl["ActionButton"..v]
			end
		else			
			self.button1 = Barbrawl["ActionButton"..v]
		end
		
		if self.database.hidden then
			Barbrawl["ActionButton"..v].group = nil
		else
			Barbrawl["ActionButton"..v].group = self.id
		end
		Barbrawl["ActionButton"..v]:UpdateTexture()
		Barbrawl["ActionButton"..v]:SetLook()
		Barbrawl["ActionButton"..v]:SetButtons()
	end
	
	self.anchor:ClearAllPoints()
	if self.button1 then 
		self.anchor:SetPoint("TOPLEFT",self.button1.frame,"TOPLEFT",-5,5)
		if self.buttonEnd then
			self.anchor:SetPoint("TOPRIGHT",self.buttonEnd.frame,"TOPRIGHT",5,5)
			self.anchor:SetPoint("BOTTOMLEFT",self.buttonEnd.frame,"BOTTOMLEFT",-5,-5)
		else
			self.anchor:SetPoint("TOPRIGHT",self.button1.frame,"TOPRIGHT",5,5)
			self.anchor:SetPoint("BOTTOMLEFT",self.button1.frame,"BOTTOMLEFT",-5,-5)	
			self.anchor:SetPoint("BOTTOMRIGHT",self.button1.frame,"BOTTOMRIGHT",5,-5)	
		end
	else
		self.anchor:Hide()
	end
	self:LoadPosition()
end

function Barbrawl.ActionBarTemplate.prototype:UpdateScale()
	for k,v in pairs(self.buttons) do
		if self.database.scale then
			Barbrawl["ActionButton"..v].frame:SetScale(self.database.scale)
		end
	end
end

function Barbrawl.ActionBarTemplate.prototype:LoadPosition()
	if self.button1 then
		local x = self.database.x
		local y = self.database.y
		if x and y then
			local s = self.button1.frame:GetEffectiveScale()
			x,y = x/s,y/s
			local padding = self.database.padding
			self.button1.frame:ClearAllPoints()
			self.button1.frame:SetPoint("BOTTOMLEFT",UIParent,"BOTTOMLEFT",x,y)
		else
			self.button1.frame:SetPoint("CENTER",UIParent,"CENTER",0,0)
		end
	end
end

function Barbrawl.ActionBarTemplate.prototype:SavePosition()
	local x,y = self.button1.frame:GetLeft(), self.button1.frame:GetBottom()
	local s = self.button1.frame:GetEffectiveScale()
	x,y = x*s,y*s
	self.database.x = x
	self.database.y = y
end





Barbrawl.ActionButtonTemplate = AceOO.Class("AceEvent-2.0","AceHook-2.0")

function Barbrawl.ActionButtonTemplate.prototype:init(id)
	Barbrawl.ActionButtonTemplate.super.prototype.init(self)
	
	self.id = id
	self.spellID = id
	
	self.shiftid = self.id+(pageOffset*1)
	self.ctrlid = self.id+(pageOffset*2)
	self.page = 0
	self.name = name
	
	self.shift = true
	self.alt = false
	self.control = false
	self.stance = false
	
	self:CreateFrame()
	self:RegisterEvents()
	self:UpdateTexture()
	self:UpdateCount()
end


function Barbrawl.ActionButtonTemplate.prototype:CreateFrame()
	local frameName = "BarbrawlButton"..self.id
	self.frame = CreateFrame("CheckButton",frameName,UIParent,"PCActionButtonTemplate")
	
	self.mods = {}
	
	self.icon = getglobal(frameName.."Icon")
	self.HotKey = getglobal(frameName.."HotKey")
	
	self.frame:RegisterForDrag("LeftButton", "RightButton","MiddleButton")
	self.frame:RegisterForClicks("LeftButtonUp", "RightButtonUp")
	self.frame:SetMovable(true)
	
	self.frame:SetScript("PreClick",function() self:PreClick(arg1) end)
	self.frame:SetScript("PostClick",function() self:PostClick(arg1) end)

	self.frame:SetScript("OnReceiveDrag",function() self:OnReceiveDrag(arg1) end)
	self.frame:SetScript("OnDragStart",function() self:OnDragStart(arg1) end)
	self.frame:SetScript("OnDragStop",function() self:OnDragStop(arg1) end)
	self.frame:SetScript("OnUpdate",function() self:OnUpdate(arg1) end)
	self.frame:SetScript("OnLeave",function() self:OnLeave() end)
	self.frame:SetScript("OnEnter",function() self:OnEnter() end)
	self.frame:Show()


	self:SetLook()
	self:SetButtons()
end

function Barbrawl.ActionButtonTemplate.prototype:SetButtons()
	if self.frame:IsVisible() then
		local checks = {"shift","alt","ctrl"}
		for k,v in ipairs(checks) do
			if self[v] == true then
				self.frame:SetAttribute(v.."-type1", "action")
				self.frame:SetAttribute(v.."-action1", self[v.."id"])		
				self.frame:SetAttribute("*type2", "action")
				self.frame:SetAttribute("*action2", self[v.."id"])		
				if Barbrawl.db.profile.keys[self.id] then
					SetBindingClick(string.upper(v).."-"..Barbrawl.db.profile.keys[self.id],self.frame:GetName(),"RightButton")
				end			
			elseif not self[v] then
				self.frame:SetAttribute(v.."-type1", "action")
				self.frame:SetAttribute(v.."-action1", ATTRIBUTE_NOOP)		
			end
		end
		self.frame:SetAttribute("type1", "action")
		self.frame:SetAttribute("action1", self.id)
		if Barbrawl.db.profile.keys[self.id] then
			SetBindingClick(Barbrawl.db.profile.keys[self.id],self.frame:GetName())
		end
	end
end

function Barbrawl.ActionButtonTemplate.prototype:SetLook()
	local frameName = "BarbrawlButton"..self.id
	local bg = getglobal(self.frame:GetName()..'NormalTexture2') or getglobal(self.frame:GetName()..'NormalTexture')
	if self.borders == false then
		self.icon:SetTexCoord(0.07,0.93,0.07,0.93)
		self.icon:ClearAllPoints()
		self.icon:SetPoint("TOPLEFT", self.frame, "TOPLEFT", 3, -3)
		self.icon:SetPoint("BOTTOMRIGHT", self.frame, "BOTTOMRIGHT", -3, 3)
		
		if not getglobal(frameName.."newBG") then
			local newBG = CreateFrame("Button", frameName.."newBG", self.frame)
			newBG:SetBackdrop({bgFile = "Interface\\Tooltips\\UI-Tooltip-Background", tile = true, tileSize = 1, edgeFile = "", edgeSize = 0, insets = {left = 0, right = 0, top = 0, bottom = 0},})
			newBG:SetBackdropColor(0,0,0,0.6)
			newBG:SetBackdropBorderColor(0.5, 0.5, 0, 0)
			newBG:SetPoint("TOPLEFT", self.frame, "TOPLEFT", -0.5, 0)
			newBG:SetPoint("BOTTOMRIGHT", self.frame, "BOTTOMRIGHT", 0.5, -0)
			newBG:SetFrameStrata("LOW")
		end
		getglobal(frameName.."newBG"):Show()

		self.hideBorder = true
		bg:SetAlpha(0)
	else	
		self.icon:ClearAllPoints()
		self.icon:SetPoint("TOPLEFT", self.frame, "TOPLEFT", 0, 0)
		self.icon:SetPoint("BOTTOMRIGHT", self.frame, "BOTTOMRIGHT", 0, 0)	
		if getglobal(frameName.."newBG") then
			getglobal(frameName.."newBG"):Hide()
		end
		self.hideBorder = false
		bg:SetAlpha(1)
	end
end

function Barbrawl.ActionButtonTemplate.prototype:RegisterEvents()
	self:RegisterEvent("Barbrawl_ShiftDown")
	self:RegisterEvent("Barbrawl_ShiftUp")
	self:RegisterEvent("Barbrawl_ControlUp")
	self:RegisterEvent("Barbrawl_ControlDown")
	self:RegisterEvent("UPDATE_BONUS_ACTIONBAR")
	self:RegisterEvent("ACTIONBAR_SHOWGRID")
	self:RegisterEvent("ACTIONBAR_HIDEGRID")
	self:RegisterEvent("UPDATE_BINDINGS")
	self:RegisterEvent("ACTIONBAR_UPDATE_STATE","UpdateState")
	self:RegisterEvent("PLAYER_LEAVE_COMBAT","UpdateState")
	self:RegisterEvent("ACTIONBAR_UPDATE_COOLDOWN",function() self:UpdateCooldown() self:UpdateUsable() end)
	self:RegisterEvent("ACTIONBAR_UPDATE_USABLE",function() self:UpdateUsable() end)
	self:RegisterEvent("PLAYER_TARGET_CHANGED","UpdateUsable")
	self:RegisterEvent("PLAYER_AURAS_CHANGED","UpdateUsable")
	self:RegisterEvent("UNIT_INVENTORY_CHANGED","UpdateCount")
	self:RegisterEvent("Barbrawl_RedRangeOption","UpdateRR")
	self:RegisterEvent("Barbrawl_HotkeyOption","UPDATE_BINDINGS")
end
	
function Barbrawl.ActionButtonTemplate.prototype:SetPoint(arg1,arg2,arg3,arg4,arg5)
	self.frame:ClearAllPoints()
	self.frame:SetPoint(arg1,arg2,arg3,arg4,arg5)
end

function Barbrawl.ActionButtonTemplate.prototype:OnDragStart(arg1)
	if self.entered == true then
		PickupAction(self.spellID)
		self:UpdateTexture()
		self:UpdateState()
		self:UpdateCount()
	end
end

function Barbrawl.ActionButtonTemplate.prototype:OnReceiveDrag(arg1)
	PlaceAction(self.spellID)
	self:UpdateTexture()
	self:UpdateState()
	self:UpdateCount()
end

function Barbrawl.ActionButtonTemplate.prototype:OnDragStop(arg1)
	self:UpdateState()
end

function Barbrawl.ActionButtonTemplate.prototype:OnDown()
	if self.frame:GetButtonState() == 'NORMAL' then
        self.frame:SetButtonState('PUSHED')
    end
	self:UpdateState()
end

function Barbrawl.ActionButtonTemplate.prototype:OnUp()
 if self.frame:GetButtonState() == 'PUSHED' then
        self.frame:SetButtonState('NORMAL')
    end
	self:UpdateState()
end

function Barbrawl.ActionButtonTemplate.prototype:PreClick(arg1)
	if Barbrawl.hotkey == true and arg1 == "RightButton" then
		Barbrawl.configFrame = self.id
		PCHotkeyWindow:Show()
		Barbrawl:Print("Press any key to bind it to this action button!")
	end
end

function Barbrawl.ActionButtonTemplate.prototype:PostClick(arg1)
	if arg1 == "LeftButton" then
		self:OnReceiveDrag(arg1)	
	end
end

function Barbrawl.ActionButtonTemplate.prototype:GetBinding(key)
	Barbrawl.db.profile.keys[self.id] = key
	self:SetButtons()
	self:UPDATE_BINDINGS()
	Barbrawl:Print(key.." bound to action button (id: "..self.id..")")
	self:UpdateState()
end

function Barbrawl.ActionButtonTemplate.prototype:UpdateRR()
	self:UpdateTexture()
	self:UpdateUsable()
end

function Barbrawl.ActionButtonTemplate.prototype:UpdateUsable()
	local icon = self.icon
	local normalTexture = getglobal(self.frame:GetName().."NormalTexture")
	local isUsable, notEnoughMana = IsUsableAction(self.spellID)
	
	if self.rangeTimer and (IsActionInRange(self.spellID) == 0) then
		if (isUsable) then
			icon:SetVertexColor(0.8, 0.1, 0.1)
			normalTexture:SetVertexColor(0.8, 0.1, 0.1)
			return
		end
	end	
	
	if ( isUsable ) then
		icon:SetVertexColor(1.0, 1.0, 1.0)
		normalTexture:SetVertexColor(1.0, 1.0, 1.0)
	elseif ( notEnoughMana ) then
		icon:SetVertexColor(0.5, 0.5, 1.0)
		normalTexture:SetVertexColor(0.5, 0.5, 1.0)
	else
		icon:SetVertexColor(0.4, 0.4, 0.4)
		normalTexture:SetVertexColor(1.0, 1.0, 1.0)
	end
end

function Barbrawl.ActionButtonTemplate.prototype:UpdateTexture()
	if self.group == nil then self.frame:Hide() return end
	local bg = getglobal(self.frame:GetName()..'NormalTexture2') or getglobal(self.frame:GetName()..'NormalTexture')
	if self.hideBorder == true then
		bg:SetAlpha(0)
	end
	local texture = GetActionTexture(self.spellID)

	
	if ( texture ) then
		self.icon:SetTexture(texture)
		self.icon:SetTexCoord(0.07, 0.93, 0.07, 0.93)
		self.icon:Show()
		self.frame:Show()
		self.frame:SetNormalTexture("Interface\\Buttons\\UI-Quickslot2")
		if Barbrawl.db.profile.oorColor == true then
			self.rangeTimer = -1
		else
			self.rangeTimer = nil
		end
	elseif self.showGrid == true then
		self.icon:Hide()
		self.frame:Show()
		bg:SetAlpha(1)
		self.frame:SetNormalTexture("Interface\\Buttons\\UI-Quickslot")
		self.rangeTimer = nil
	else
		self.frame:Hide()
		self.icon:Hide()
		self.rangeTimer = nil
	end
	self:UPDATE_BINDINGS()
end

function Barbrawl.ActionButtonTemplate.prototype:Barbrawl_ShiftDown()
	if self.shift == true and self.bonus ~= true then
		self:SetPage(1)
	end
end

function Barbrawl.ActionButtonTemplate.prototype:Barbrawl_ShiftUp()
	if self.bonus ~= true then
		self:SetPage(0)
	end
end

function Barbrawl.ActionButtonTemplate.prototype:Barbrawl_ControlDown()
	if self.ctrl == true and self.bonus ~= true then
		self:SetPage(2)
	end
end

function Barbrawl.ActionButtonTemplate.prototype:Barbrawl_ControlUp()
	if self.bonus ~= true then
		self:SetPage(0)
	end
end

function Barbrawl.ActionButtonTemplate.prototype:UPDATE_BONUS_ACTIONBAR()
	if self.stance == true then
		if GetActionBarPage() > 1 then
			self.bonus = true
		else
			self.bonus = false
		end		
		self:SetPage(GetActionBarPage()-1)
	end
end

function Barbrawl.ActionButtonTemplate.prototype:SetPage(page)
	self.page = page
	self.spellID = self.id+(pageOffset*self.page)
	
	self:UpdateTexture()
	self:UpdateUsable()
	self:UpdateCooldown()	
	self:UpdateCount()
end

function Barbrawl.ActionButtonTemplate.prototype:UpdateCount()
	local text = getglobal(self.frame:GetName().."Count")
	if ( IsConsumableAction(self.spellID) ) then
		text:SetText(GetActionCount(self.spellID))
	else
		text:SetText("")
	end
end

function Barbrawl.ActionButtonTemplate.prototype:UPDATE_BINDINGS()
	if Barbrawl.db.profile.hotkey == true then
		local hotkeyID = Barbrawl.db.profile.keys[self.id]
		
		if hotkeyID then
			self.HotKey:SetText(hotkeyID)
		end
	else
		self.HotKey:SetText("")
	end
end

function Barbrawl.ActionButtonTemplate.prototype:ACTIONBAR_SHOWGRID()
	self.showGrid = true
	self:UpdateTexture()
end

function Barbrawl.ActionButtonTemplate.prototype:ACTIONBAR_HIDEGRID()
	self.showGrid = false
	self:UpdateTexture()
end

function Barbrawl.ActionButtonTemplate.prototype:UpdateState()
	if ( (IsAttackAction(self.spellID) and IsCurrentAction(self.spellID)) or IsAutoRepeatAction(self.spellID) ) then
		self.frame:SetChecked(1)
	else
		self.frame:SetChecked(0)
	end
end

function Barbrawl.ActionButtonTemplate.prototype:UpdateCooldown()

	local cooldown = getglobal(self.frame:GetName().."Cooldown")
	local start, duration, enable = GetActionCooldown(self.spellID)
	CooldownFrame_SetTimer(cooldown, start, duration, enable)
	
end

function Barbrawl.ActionButtonTemplate.prototype:OnUpdate(arg1)

	local changeRange = false
	
	if self.rangeTimer then
		self.rangeTimer = self.rangeTimer - arg1
		if ( self.rangeTimer <= 0 ) then
			self.rangeTimer = TOOLTIP_UPDATE_TIME
		end
	
      if ( self.rangeTimer <= arg1 ) then
		 local newRange = nil
		 if ( IsActionInRange( self.spellID ) == 0) then
			newRange = true
		 end
		 if (self.redRangeFlag ~= newRange) then
			self.redRangeFlag = newRange
			changeRange = true
		 end
      end
	end

   if (changeRange) then
      self:UpdateUsable()
   end
   
end

function Barbrawl.ActionButtonTemplate.prototype:OnEnter()
	if ( GetCVar("UberTooltips") == "1" ) then
		GameTooltip_SetDefaultAnchor(GameTooltip, this);
	else
		if ( this:GetParent() == MultiBarBottomRight or this:GetParent() == MultiBarRight or this:GetParent() == MultiBarLeft ) then
			GameTooltip:SetOwner(this, "ANCHOR_LEFT");
		else
			GameTooltip:SetOwner(this, "ANCHOR_RIGHT");
		end
		
	end
	
	if ( GameTooltip:SetAction(self.spellID) ) then
		this.updateTooltip = TOOLTIP_UPDATE_TIME;
	else
		this.updateTooltip = nil;
	end
	self.entered = true
end

function Barbrawl.ActionButtonTemplate.prototype:OnLeave()
	this.updateTooltip = nil
	GameTooltip:Hide()
	self.entered = false
end

---------- Ripped from Omni, all credit goes to him

local function GetFormattedTime(secs)
	if (secs > 86400) then
		return ceil(secs / 86400) .. "d", mod(secs, 86400)
	elseif (secs > 3600) then
		return ceil(secs / 3600) .. "h", mod(secs, 3600)
	elseif (secs > 60) then
		return ceil(secs / 60) .. "m", mod(secs, 60)
	end
	return floor(secs + 0.5), secs - floor(secs)
end

--OnUpdate Function
local function Text_OnUpdate()
	if( this.timeToNextUpdate <= 0 or not this.icon:IsVisible() ) then
		local remain = this.duration - (GetTime() - this.start)

		if( remain > 0 and this.icon:IsVisible() ) then
			local text, toNextUpdate = GetFormattedTime( remain )
			this.text:SetText( text )
			this.timeToNextUpdate = toNextUpdate
		else
			this:Hide()
		end
	else
		this.timeToNextUpdate = this.timeToNextUpdate - arg1
	end
end

--Constructor
local function CreateCooldownCount(cooldown, start, duration)
	local textFrame = CreateFrame("Frame", nil, cooldown:GetParent())
	cooldown.textFrame = textFrame
	
	textFrame:SetAllPoints(cooldown:GetParent())
	textFrame:SetFrameLevel(cooldown.textFrame:GetFrameLevel() + 1)
	
	textFrame.text = cooldown.textFrame:CreateFontString(nil, "OVERLAY")
	textFrame.text:SetFont(STANDARD_TEXT_FONT, 14, "OUTLINE")
	textFrame.text:SetTextColor(1, 1, 0.2)
	textFrame.text:SetPoint("CENTER", cooldown.textFrame, "CENTER", 0, 1)
	
	textFrame.icon = 
		--standard action button icon, $parentIcon
		getglobal(cooldown:GetParent():GetName() .. "Icon") or 
		--standard item button icon,  $parentIconTexture
		getglobal(cooldown:GetParent():GetName() .. "IconTexture") or 
		--discord action button, $parent_Icon
		getglobal(cooldown:GetParent():GetName() .. "_Icon")
	
	if(textFrame.icon) then
		textFrame:SetScript("OnUpdate", Text_OnUpdate)
	end
	
	textFrame:Hide()
	
	return textFrame
end

--Function Hooks
local oCooldownFrame_SetTimer = CooldownFrame_SetTimer
CooldownFrame_SetTimer = function(cooldownFrame, start, duration, enable)
	oCooldownFrame_SetTimer(cooldownFrame, start, duration, enable)
	
	if ( start > 0 and duration > 0 and enable > 0) and Barbrawl.db.profile.cooldown == true then
		if( duration > 3 ) then
			local cooldownCount = cooldownFrame.textFrame or CreateCooldownCount(cooldownFrame, start, duration)	
			cooldownCount.start = start
			cooldownCount.duration = duration
			cooldownCount.timeToNextUpdate = 0
			cooldownCount:Show()
		elseif( cooldownFrame.textFrame ) then
			cooldownFrame.textFrame:Hide()
		end	
	elseif( cooldownFrame.textFrame ) then
		cooldownFrame.textFrame:Hide()
	end
end
